<script setup lang="ts">
import { RouterLink } from 'vue-router'
import { storeToRefs } from 'pinia'
import { onClickOutside } from '@vueuse/core'
import CartItem from '@/components/cart/CartItem.vue'
import { useCartStore } from '@/stores/cart'
import { computed, ref } from 'vue'

const store = useCartStore()
const { isOpen, items, totalCartPrice } = storeToRefs(store)
const { closeCart } = store
const classes = computed(() => isOpen.value ? 'cart-dropdown open' : 'cart-dropdown')

const target = ref(null)
onClickOutside(target, () => isOpen && closeCart())

const isEmptyCart = computed(() => items.value.length === 0)

</script>
<template>
  <div v-if="isOpen" class="cart-overlay"></div>
  <div :class="classes" id="cart-dropdown" ref="target">
    <div class="cart-content-wrap">
      <div class="cart-header">
        <h2 class="header-title">Cart review</h2>
        <button class="cart-close sidebar-close" @click.prevent.stop="closeCart()">
          <i class="fas fa-times"></i>
        </button>
      </div>
      <div v-if="!isEmptyCart" class="cart-body">
        <ul class="cart-item-list">
          <CartItem v-for="item of items" :key="item.selectedSize.id" :item="item"/>
        </ul>
      </div>
      <div v-else class="cart-body centered">
        Your cart is empty
      </div>
      <div v-if="!isEmptyCart" class="cart-footer">
        <h3 class="cart-subtotal">
          <span class="subtotal-title">Subtotal:</span>
          <span class="subtotal-amount">${{totalCartPrice}}</span>
        </h3>
        <div class="group-btn">
          <RouterLink
              class="axil-btn btn-bg-primary viewcart-btn"
              :to="{ name: 'cart' }"
              @click="closeCart()"
          >
            View Cart
          </RouterLink>
          <RouterLink
              class="axil-btn btn-bg-secondary checkout-btn"
              :to="{ name: 'checkout' }"
              @click="closeCart()"
          >
            Checkout
          </RouterLink>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.cart-overlay {
  position: fixed;
  background: rgba(0,0,0,0.4);
  top: 0;
  left: 0;
  width: 100%;
  height: 100vh;
  z-index: 10;
}
.cart-body {
  &.centered {
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 20px;
  }
}
</style>